// libHook.cpp

#define WIN32_LEAN_AND_MEAN
#define _WIN32_WINNT 0x0400
#include <windows.h>
#include "libHook.h"

// st@CTCY̐ߖ
#ifdef NDEBUG
	#pragma comment(linker, "/nodefaultlib")
	#pragma comment(linker, "/entry:\"DllMain\"")
#endif

static HINSTANCE theInstance = 0;

#pragma data_seg(".libHook_shared_data")
	HWND  theWindow			= 0;
	UINT  theKeyMessage		= 0;
	UINT  theMouseMessage	= 0;
	HHOOK theKeyHook		= 0;
	HHOOK theMouseHook		= 0;
#pragma data_seg()

BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	theInstance = (HINSTANCE)hModule;
    return TRUE;
}
static LRESULT CALLBACK KeyHookProc(int code, WPARAM wParam, LPARAM lParam)
{
    KBDLLHOOKSTRUCT* khook = (KBDLLHOOKSTRUCT*)lParam;
    if(code == HC_ACTION)
		PostMessage(theWindow, theKeyMessage, wParam, khook->vkCode);
	return CallNextHookEx(theKeyHook, code, wParam, lParam);
}
static LRESULT CALLBACK MouseHookProc(int code, WPARAM wParam, LPARAM lParam)
{
    MOUSEHOOKSTRUCT* mhook = (MOUSEHOOKSTRUCT*)lParam;
    if(code == HC_ACTION)
		PostMessage(theWindow, theMouseMessage, wParam, (LPARAM)mhook->hwnd);
	return CallNextHookEx(theMouseHook, code, wParam, lParam);
}
LIBHOOK_API BOOL BeginHook(HWND hWnd, UINT wmKey, UINT wmMouse)
{
	if(theWindow != NULL)
		return FALSE;
	theWindow		= hWnd;
	theKeyMessage	= wmKey;
	theMouseMessage	= wmMouse;
	// Keyboard Hook
	if(wmKey != 0)
	{
		theKeyHook = SetWindowsHookEx(WH_KEYBOARD_LL, KeyHookProc, theInstance, 0);
		if(theKeyHook == NULL)
		{
			EndHook();
			return FALSE;
		}
	}
	// Mouse Hook
	if(wmMouse != 0)
	{
		theMouseHook = SetWindowsHookEx(WH_MOUSE, MouseHookProc, theInstance, 0);
		if(theMouseHook == NULL)
		{
			EndHook();
			return FALSE;
		}
	}
	return TRUE;
}
LIBHOOK_API BOOL EndHook()
{
	if(theMouseHook)
	{
		UnhookWindowsHookEx(theMouseHook);
		theMouseHook = NULL;
	}
	if(theKeyHook)
	{
		UnhookWindowsHookEx(theKeyHook);
		theKeyHook = NULL;
	}
	theWindow = NULL;
	return TRUE;
}
