// pipette.cpp

#include "stdafx.h"
#include "../libHook/libHook.h"
#include "resource.h"

////////////////////////////////////////////////////////////
//

#ifdef NDEBUG

#pragma comment(linker, "/nodefaultlib")

extern "C" void __cdecl WinMainCRTStartup(void)
{
	int mainret;
	char *lpszCommandLine;
	STARTUPINFO StartupInfo;
	extern int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow);

	lpszCommandLine = GetCommandLine();

	// GetCommandLine()ŕԂ镶ɂ͎giexej̃pXĂ̂ɑ΂A
	// WinMain()ɓnR}hCł͂ꂪĂ邽߁A
	// ̃G~[VB
	if(*lpszCommandLine == '"')
	{
		while(*++lpszCommandLine && (*lpszCommandLine != '"'));
		if(*lpszCommandLine == '"')
			lpszCommandLine++;
	}
	else
	{
		while(*lpszCommandLine > ' ')
			lpszCommandLine++;
	}

	while(*lpszCommandLine && (*lpszCommandLine <= ' '))
		lpszCommandLine++;

	StartupInfo.dwFlags = 0;
	GetStartupInfo(&StartupInfo);
	
	mainret = WinMain(GetModuleHandle(NULL), NULL, lpszCommandLine,
		StartupInfo.dwFlags & STARTF_USESHOWWINDOW ? StartupInfo.wShowWindow : SW_SHOWDEFAULT);

	ExitProcess(mainret);
}

#endif

////////////////////////////////////////////////////////////
//

INT CALLBACK DlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
INT CALLBACK InputBoxProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
enum
{
	WM_KEYHOOK = WM_USER + 100,
	WM_MOUSEHOOK,
};

HBRUSH		theBrush;
COLORREF	theColor;
POINT		theCursorPos;
TCHAR		theProfileName[MAX_PATH];
TCHAR		theOutputFormat[1024];
UINT		theCaptureKey;
const LPCSTR	DEFAULT_OUTPUT_FORMAT = "(%x, %y) RGB(%r, %g, %b)";
const UINT		DEFAULT_CAPTURE_KEY   = VK_F2;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	::GetModuleFileName(hInstance, theProfileName, MAX_PATH);
	UINT len = lstrlen(theProfileName);
	if(lstrcmpi(theProfileName+len-4, TEXT(".exe")) == 0)
		lstrcpy(theProfileName+len-4, ".ini");
	else
		lstrcat(theProfileName, ".ini");
	GetPrivateProfileString("Main", "OutputFormat", DEFAULT_OUTPUT_FORMAT, theOutputFormat, 1024, theProfileName);
	theCaptureKey = GetPrivateProfileInt("Main", "CaptureKey", DEFAULT_CAPTURE_KEY, theProfileName);
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, DlgProc);
	WritePrivateProfileString("Main", "OutputFormat", theOutputFormat, theProfileName);
	TCHAR buffer[256];
	wsprintf(buffer, "%d", theCaptureKey);
	WritePrivateProfileString("Main", "CaptureKey", buffer, theProfileName);
	return 0;
}

////////////////////////////////////////////////////////////
//

void	FormatOutput(LPTSTR buffer, const POINT& ptScreen, const POINT& ptTarget, COLORREF color)
{
	LPTSTR o = buffer;
	for(LPCSTR c = theOutputFormat; *c != '\0'; c++)
	{
		if(*c == '%')
		{
			TCHAR fmt[64];
			switch(*(c+1))
			{
			case 'x': wsprintf(fmt, "%4d", ptScreen.x); break;
			case 'y': wsprintf(fmt, "%4d", ptScreen.y); break;
			case 'X': wsprintf(fmt, "%4d", ptTarget.x); break;
			case 'Y': wsprintf(fmt, "%4d", ptTarget.y); break;
			case 'r': wsprintf(fmt, "%3d", (int)GetRValue(color)); break;
			case 'g': wsprintf(fmt, "%3d", (int)GetGValue(color)); break;
			case 'b': wsprintf(fmt, "%3d", (int)GetBValue(color)); break;
			case 'R': wsprintf(fmt, "%02X", (int)GetRValue(color)); break;
			case 'G': wsprintf(fmt, "%02X", (int)GetGValue(color)); break;
			case 'B': wsprintf(fmt, "%02X", (int)GetBValue(color)); break;
			default:
				*o++ = *c;
				continue;
			}
			lstrcpy(o, fmt);
			o += lstrlen(fmt);
			c++;
			continue;
		}
		else
			*o++ = *c;
	}
	*o = '\0';
}
void	OnKeyHook(HWND hWnd, UINT msg, UINT key)
{
	if(msg == WM_KEYDOWN && key == theCaptureKey)
	{
		TCHAR buffer[1024];
		GetDlgItemText(hWnd, IDC_CURSOR, buffer, 1024);
		lstrcat(buffer, "\r\n");
		HWND hHistory = GetDlgItem(hWnd, IDC_HISTORY);
		SendMessage(hHistory, EM_SETSEL, 0, 0);
		SendMessage(hHistory, EM_REPLACESEL, FALSE, (LPARAM)buffer);
	}
}
void	OnMouseHook(HWND hWnd, UINT msg, HWND hTarget)
{
	switch(msg)
	{
	case WM_NCMOUSEMOVE:
	case WM_MOUSEMOVE:
	{
		GetCursorPos(&theCursorPos);
		HWND hDesktop = GetDesktopWindow();
		HDC hDC = GetWindowDC(hDesktop);
		COLORREF color = GetPixel(hDC, theCursorPos.x, theCursorPos.y);
		ReleaseDC(hDesktop, hDC);
		// Cursor
		POINT ptTarget = theCursorPos;
		ScreenToClient(hTarget, &ptTarget);
		TCHAR buffer[1024];
		FormatOutput(buffer, theCursorPos, ptTarget, color);
		SetDlgItemText(hWnd, IDC_CURSOR, buffer);  
		// Color
		if(theColor != color)
		{
			theColor = color;
			if(theBrush != NULL)
			{
				DeleteObject(theBrush);
				// InvalidateRect()ɃuVĂȂƂȂ݂BB
				theBrush = CreateSolidBrush(theColor);
			}
			InvalidateRect(GetDlgItem(hWnd, IDC_COLOR), NULL, TRUE);
		}
		//
		break;
	}
	default:
		break;
	}
}
INT CALLBACK DlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		BeginHook(hWnd, WM_KEYHOOK, WM_MOUSEHOOK);
		SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
		break;
	case WM_CLOSE:
		EndHook();
		if(theBrush != NULL)
			DeleteObject(theBrush);
		EndDialog(hWnd, 0);
		break;
	case WM_KEYHOOK:
		OnKeyHook(hWnd, wParam, lParam);
		break;
	case WM_MOUSEHOOK:
		OnMouseHook(hWnd, wParam, (HWND)lParam);
		break;
	case WM_CTLCOLORSTATIC:
		if(GetDlgItem(hWnd, IDC_COLOR) == (HWND)lParam)
		{
			if(theBrush == NULL)
				theBrush = CreateSolidBrush(theColor);
			return (LRESULT)theBrush;
		}
		return FALSE;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_SETUP:
			DialogBox((HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), MAKEINTRESOURCE(IDD_INPUTBOX), NULL, InputBoxProc);
			break;
		case IDC_CLEAR:
			SetWindowText(GetDlgItem(hWnd, IDC_HISTORY), NULL);
			break;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

BOOL CenterWindow(HWND hwndChild, HWND hwndParent)
{
	RECT	rcChild, rcParent, rcWorkArea;
	int	wChild, hChild, wParent, hParent;
	int	xNew, yNew;
	BOOL	bResult;

	GetWindowRect(hwndChild,&rcChild);
	wChild = rcChild.right - rcChild.left;
	hChild = rcChild.bottom - rcChild.top;
	if (hwndParent)
		GetWindowRect(hwndParent,&rcParent);
	else
		GetWindowRect(GetDesktopWindow(),&rcParent);
	wParent = rcParent.right - rcParent.left;
	hParent = rcParent.bottom - rcParent.top;

	bResult = SystemParametersInfo(SPI_GETWORKAREA,sizeof(RECT),&rcWorkArea,0);
	if (!bResult) {
		rcWorkArea.left = rcWorkArea.top = 0;
		rcWorkArea.right = GetSystemMetrics(SM_CXSCREEN);
		rcWorkArea.bottom = GetSystemMetrics(SM_CYSCREEN);
	}

	xNew = rcParent.left + ((wParent-wChild) / 2);
	if (xNew < rcWorkArea.left) {
		xNew = rcWorkArea.left;
	}
	else if ((xNew+wChild) > rcWorkArea.right) {
		xNew = rcWorkArea.right - wChild;
	}

	yNew = rcParent.top  + ((hParent-hChild) / 2);
	if (yNew < rcWorkArea.top) {
		yNew = rcWorkArea.top;
	}
	else if ((yNew+hChild) > rcWorkArea.bottom) {
		yNew = rcWorkArea.bottom - hChild;
	}

	return SetWindowPos(hwndChild, HWND_TOP, xNew, yNew, 0, 0, SWP_NOSIZE);
}

INT CALLBACK InputBoxProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		CenterWindow(hWnd, GetParent(hWnd));
		SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
		SetDlgItemText(hWnd, IDC_FORMAT, theOutputFormat);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			GetDlgItemText(hWnd, IDC_FORMAT, theOutputFormat, 1024);
			EndDialog(hWnd, IDOK);
			break;
		case IDCANCEL:
			EndDialog(hWnd, IDCANCEL);
			break;
		}
	default:
		return FALSE;
	}
	return TRUE;
}
